require "canary_ipa/railtie"

module CanaryIpa
  class << self
    attr_writer :host, :port

    def host
      @host || ENV["CANARY_MONITORING_AGENT_HOST"] || "127.0.0.1"
    end
    def port
      @port || (ENV["CANAY_MONITORING_AGENT_PORT"] || "51712").to_i
    end
    def config
      yield self
    end
  end

  module NetHttpExtensions
    @@sock = UDPSocket.new
    def request(req, body = nil, &block)
      start = Process.clock_gettime(Process::CLOCK_MONOTONIC)
      result = super(req, body, &block)
      delta = Process.clock_gettime(Process::CLOCK_MONOTONIC) - start
      delta_ms = delta * 1000
      @@sock.send("0\t#{req.method}\t#{@address}\t#{req.path}\t#{delta_ms}\n", 0, CanaryIpa.host, CanaryIpa.port)
      result
    end
  end
end

class Net::HTTP
  prepend CanaryIpa::NetHttpExtensions
end
